Index: main/trunk/greenstone2/perllib/inexport.pm
===================================================================
--- main/trunk/greenstone2/perllib/inexport.pm	(revision 32585)
+++ main/trunk/greenstone2/perllib/inexport.pm	(revision 32586)
@@ -680,5 +680,5 @@
     push @$plugout,("-gzip_output")                if ($gzip);
     push @$plugout,("-output_handle",$out)         if (defined $out);
-    push @$plugout,("-site_name",$self->{'site'})  if (defined $self->{'site'});
+    push @$plugout,("-site",$self->{'site'})  if (defined $self->{'site'});
 
     push @$plugout,("-xslt_file",$xsltfile)        if (defined $xsltfile && $xsltfile ne "");
Index: main/trunk/greenstone2/perllib/plugins/GreenstoneSQLPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/GreenstoneSQLPlugin.pm	(revision 32585)
+++ main/trunk/greenstone2/perllib/plugins/GreenstoneSQLPlugin.pm	(revision 32586)
@@ -161,5 +161,5 @@
 	'type' => "enum",
 	'list' => $rollback_on_cancel_list,
-	'deft' => "true", # TODO Q: what's the better default? If "true", any memory concerns?
+	'deft' => "false", # TODO Q: what's the better default? If "true", any memory concerns?
 	'reqd' => "no",
 	'hiddengli' => "no"},
@@ -236,5 +236,5 @@
 
     ####################
-#    print "@@@ SITE NAME: ". $self->{'site_name'} . "\n" if defined $self->{'site_name'};
+#    print "@@@ SITE NAME: ". $self->{'site'} . "\n" if defined $self->{'site'};
 #    print "@@@ COLL NAME: ". $ENV{'GSDLCOLLECTION'} . "\n";
 
@@ -270,5 +270,5 @@
     }
     
-    my $db_name = $self->{'site_name'} || "greenstone2"; # one database per GS3 site, for GS2 the db is called greenstone2
+    my $db_name = $self->{'site'} || "greenstone2"; # one database per GS3 site, for GS2 the db is called greenstone2
 
     # Attempt to use the db, create it if it doesn't exist (but don't create the tables yet)
@@ -332,5 +332,5 @@
     print STDERR "   Building with removeold option set, so deleting current collection's tables if they exist\n" if($self->{'verbosity'});
     
-    # if we're in here, we'd already have run 'use database <site_name>;' during sub init()
+    # if we're in here, we'd already have run 'use database <site>;' during sub init()
     # so we can go ahead and delete the collection's tables
     my $gs_sql = $self->{'gs_sql'};
Index: main/trunk/greenstone2/perllib/plugins/PrintInfo.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/PrintInfo.pm	(revision 32585)
+++ main/trunk/greenstone2/perllib/plugins/PrintInfo.pm	(revision 32586)
@@ -53,6 +53,6 @@
       'reqd' => "no",
       'hiddengli' => "yes" },
-    { 'name' => "site_name",
-      'desc' => "{PrintInfo.site_name}",
+    { 'name' => "site",
+      'desc' => "{PrintInfo.site}",
       'type' => "string",
       'reqd' => "no",
@@ -86,11 +86,11 @@
     # the args, just return the object. 
     # gsdlinfo must come before gs_version. both are set by plugin.pm
-    # The optional -site_name <site> (present only for GS3 and when not doing gsdlinfo),
+    # The optional -site <site-name> (present only for GS3 and when not doing gsdlinfo),
     # if it is there, also appears before gs_version and is also set by plugin.pm
     my $v=0;
     foreach my $strArg (@{$args})
     {
-	if($v eq "-site_name") {
-	    $self->{'site_name'} = $strArg;
+	if($v eq "-site") {
+	    $self->{'site'} = $strArg;
 	}
 	elsif($v eq "-gs_version") {
@@ -103,5 +103,5 @@
 	    #return bless $self, $class;
 	}
-	elsif ($strArg eq "-gs_version" || $strArg eq "-site_name") {	    
+	elsif ($strArg eq "-gs_version" || $strArg eq "-site") {	    
 	    $v = $strArg;
 	}
Index: main/trunk/greenstone2/perllib/plugouts/BasePlugout.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugouts/BasePlugout.pm	(revision 32585)
+++ main/trunk/greenstone2/perllib/plugouts/BasePlugout.pm	(revision 32586)
@@ -45,6 +45,6 @@
 
 my $arguments = [
-        { 'name' => "site_name",
-	  'desc' => "{BasPlugout.site_name}",
+        { 'name' => "site",
+	  'desc' => "{BasPlugout.site}",
 	  'type' => "string",
 	  'reqd' => "no",
@@ -149,9 +149,9 @@
 		return bless $self, $class;
 	    }	    
-	    elsif ($strArg eq "-site_name") {
+	    elsif ($strArg eq "-site") {
 		$v = $strArg;
 	    }
-	    elsif($v eq "-site_name") {
-		$self->{'site_name'} = $strArg;
+	    elsif($v eq "-site") {
+		$self->{'site'} = $strArg;
 	    }
 	}
Index: main/trunk/greenstone2/perllib/plugouts/GreenstoneSQLPlugout.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugouts/GreenstoneSQLPlugout.pm	(revision 32585)
+++ main/trunk/greenstone2/perllib/plugouts/GreenstoneSQLPlugout.pm	(revision 32586)
@@ -41,5 +41,5 @@
 # + TODO: SIGTERM rollback and disconnect?
 # + TODO Q: what about verbosity for debugging, instead of current situation of printing out upon debug set at the expense of writing to db
-# TODO Q: introduced site_name param to plugins and plugouts. Did I do it right? And should they have hiddengli = "yes"
+#X TODO Q: introduced site param to plugins and plugouts. Did I do it right? And should they have hiddengli = "yes". No longer a param
 # Did I do the pass by ref in docprint's escape and unescape textref functions correctly, and how they're called here?
 #   Any more optimisation I can do around this?
@@ -88,5 +88,5 @@
       'type' => "enum",
       'list' => $rollback_on_cancel_list,
-      'deft' => "true", # TODO Q: what's the better default? If "true", any memory concerns?
+      'deft' => "false", # TODO Q: what's the better default? If "true", any memory concerns?
       'reqd' => "no",
       'hiddengli' => "no"},
@@ -155,5 +155,5 @@
 
     ############ LOAD NECESSARY OPTIONS ###########
-    #print "@@@ plugout SITE NAME: ". $self->{'site_name'} . "\n" if defined $self->{'site_name'};
+    #print "@@@ plugout SITE NAME: ". $self->{'site'} . "\n" if defined $self->{'site'};
     #print STDERR "########## COLLECTION: ". $ENV{'GSDLCOLLECTION'}."\n";
 
@@ -189,5 +189,5 @@
     #die("@@@@ TEST. Connected successfully. Testing gssql::destructor.\n"); # WORKS
     
-    my $db_name = $self->{'site_name'} || "greenstone2"; # one database per GS3 site, for GS2 the db is called greenstone2
+    my $db_name = $self->{'site'} || "greenstone2"; # one database per GS3 site, for GS2 the db is called greenstone2
     my $proc_mode = $self->{'process_mode'};
     
Index: main/trunk/greenstone2/perllib/strings.properties
===================================================================
--- main/trunk/greenstone2/perllib/strings.properties	(revision 32585)
+++ main/trunk/greenstone2/perllib/strings.properties	(revision 32586)
@@ -1234,5 +1234,5 @@
 PrintInfo.desc:Most base plugin, handles printing info (using pluginfo.pl) and parsing of the arguments.
 
-PrintInfo.site_name:The name of the Greenstone 3 site. The default site for a GS3 installation is localsite.
+PrintInfo.site:The name of the Greenstone 3 site. The default site for a GS3 installation is localsite.
 
 ProCitePlugin.desc:A plugin for (exported) ProCite databases
@@ -1418,5 +1418,5 @@
 BasPlugout.no_auxiliary_databases:Don't generate archivesinf databases - useful when exporting.
 # '
-BasPlugout.site_name:The name of the Greenstone 3 site. The default site for a GS3 installation is localsite.
+BasPlugout.site:The name of the Greenstone 3 site. The default site for a GS3 installation is localsite.
 BasPlugout.output_handle: the file descriptor used to receive output data
 BasPlugout.output_info:The reference to an arcinfo object used to store information about the archives.